<?xml version="1.0"?>

<!--  
    The strategy taken here is to include all rules by default, and exclude rules as we find a need.
-->

<ruleset name="Custom ruleset"
    xmlns="http://pmd.sourceforge.net/ruleset/2.0.0"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://pmd.sourceforge.net/ruleset/2.0.0 http://pmd.sourceforge.net/ruleset_2_0_0.xsd">

    <description>Custom Rule Set</description>  

    <rule ref="category/java/bestpractices.xml">
        <exclude name="AbstractClassWithoutAbstractMethod"/>
        <exclude name="JUnitAssertionsShouldIncludeMessage"/>
        <exclude name="JUnitTestsShouldIncludeAssert"/>
        <exclude name="SystemPrintln"/> 
        <exclude name="UseVarargs"/> 
    </rule>
    
    <rule ref="category/java/codestyle.xml">
        <exclude name="AtLeastOneConstructor"/>
        <exclude name="CommentDefaultAccessModifier"/>
        <exclude name="ConfusingTernary"/>
        <exclude name="DefaultPackage"/>
        <exclude name="LocalVariableCouldBeFinal"/>
        <exclude name="LongVariable"/>
        <exclude name="MethodArgumentCouldBeFinal"/>
        <exclude name="MethodNamingConventions"/>            
        <exclude name="OnlyOneReturn"/>
        <exclude name="ShortClassName"/>
        <exclude name="ShortVariable"/>
        <exclude name="TooManyStaticImports"/>
        <exclude name="UselessParentheses"/>
    </rule>    
    
    <rule ref="category/java/design.xml">
        <exclude name="AvoidCatchingGenericException"/>           
        <exclude name="DataClass"/>
        <exclude name="LawOfDemeter"/>
        <exclude name="LoosePackageCoupling"/>
        <exclude name="SignatureDeclareThrowsException"/>   
        <exclude name="SimplifyBooleanReturns"/>
        <exclude name="TooManyMethods"/>
        <exclude name="UseUtilityClass"/>
    </rule>
    
    <rule ref="category/java/documentation.xml">
        <exclude name="UncommentedEmptyConstructor"/>
    </rule>
    
    <rule ref="category/java/documentation.xml/CommentSize">
        <properties>
            <property name="maxLines" value="32"/>
            <property name="maxLineLength" value="120"/>
        </properties>
    </rule>
    
    <rule ref="category/java/errorprone.xml">
        <exclude name="AvoidCatchingNPE"/>           
        <exclude name="AvoidDuplicateLiterals"/>           
        <exclude name="AvoidLiteralsInIfCondition"/>
        <exclude name="BeanMembersShouldSerialize"/>
        <exclude name="DataflowAnomalyAnalysis"/>
        <exclude name="DoNotCallSystemExit"/>
        <exclude name="EmptyCatchBlock"/>
    </rule>
    
    <rule ref="category/java/multithreading.xml">
        <exclude name="UseConcurrentHashMap"/>
    </rule>
    
    <rule ref="category/java/performance.xml">
        <exclude name="AvoidInstantiatingObjectsInLoops"/>
        <exclude name="ConsecutiveAppendsShouldReuse"/>
        <exclude name="ConsecutiveLiteralAppends"/>
        <exclude name="InsufficientStringBufferDeclaration"/>
    </rule>
    
    <rule ref="category/java/security.xml">
    </rule>
    
</ruleset>
